Unit GRZ; //13.09.2013  Groe Ganzzahlen (freie Software by Heizkoerper)

//Im Array[0] ist das Vorzeichen (1 gleich Negativ sonst 0) oder der
//Fehlerstatus (9 bis 12) abgespeichert.

Interface

Type BigInt=Array Of Int64;

Function StrToGRZ(s:String):BigInt;
Function GRZToStr(z:BigInt):String;
Function AddGRZ(Zahl1,Zahl2:BigInt):BigInt;
Function SubGRZ(Zahl1,Zahl2:BigInt):BigInt;
Function MulGRZ(Zahl1,Zahl2:BigInt):BigInt;
Function DivGRZ(Zahl1,Zahl2:BigInt):BigInt;
Function ModGRZ(Zahl1,Zahl2:BigInt):BigInt;
Function ggTGRZ(x,y:BigInt):BigInt;
Function kgVGRZ(x,y:BigInt):BigInt;

Const Fehlermeldung:Array[9..12] Of String=(
       'Falsche Zahleneingabe',
       'Nicht durch Null teilen bei der Division!',
       'Nicht durch Null teilen bei der Rest-Division!',
       'Beide Argumente beim kgV drfen nicht gleichzeitig Null sein!');

Implementation

Uses  SysUtils;

Var   LaengeInt:Byte;
      MaxInt   :Integer;

Function Value(s:String):Extended;
Var Fehler:Integer;
    Zahl  :Extended;
Begin Val(s,Zahl,Fehler);Value:=Zahl End;

Function StrToGRZ(s:String):BigInt;
 Function StrVorzeichenErgaenzen(s:String):String;
 Begin
  If s[1]='+' Then s[1]:=' ';
  If (s[1]>='0') And (s[1]<='9') Then s:=' '+s;
  StrVorzeichenErgaenzen:=s
 End;
 Function StrVerkuerzen(s:String):String;
 Var i:Integer;
     h:String;
 Begin
  If Int(Value(s))=0 Then Begin StrVerkuerzen:=' 0';Exit End;
  i:=2;
  While s[i]='0' Do Inc(i);
  h:=s[1]+Copy(s,i,Length(s)-i+1);
  If (h=' ') Or (h='+') Or (h='-') Then h:=' 0';
  If h='-0' Then h:=' 0';
  StrVerkuerzen:=h
 End;
 Function StrVerlaengern(s,Null:String):String;
 Var Laenge:Integer;
 Begin
  Laenge:=Length(s);
  StrVerlaengern:=s[1]+Copy(Null,1,Length(Null)-Laenge+1)+Copy(s,2,Laenge)
 End;
Var Ordnummer,Laenge,n,m:Integer;
    Zahl                :BigInt;
Begin
 s:=StrVerkuerzen(StrVorzeichenErgaenzen(s));Laenge:=Length(s);
 For n:=2 To Laenge Do
  Begin
   Ordnummer:=Ord(s[n]);
   If Not((Ordnummer<58) And (Ordnummer>47)) Then
    Begin SetLength(Zahl,2);Zahl[0]:=9;StrToGRZ:=Zahl;Exit End
  End;
 If (Laenge-1)/LaengeInt<>(Laenge-1) Div LaengeInt Then
  Begin
   s:=StrVerlaengern(s,StringOfChar('0',((Laenge-1) Div LaengeInt+1)*LaengeInt));
   Laenge:=Length(s)
  End;
 SetLength(Zahl,(Laenge-1) Div LaengeInt+1);n:=(Laenge-1) Div LaengeInt;m:=2;
 While m<=Laenge Do
  Begin Zahl[n]:=Trunc(Value(Copy(s,m,LaengeInt)));Dec(n);Inc(m,LaengeInt) End;
 If s[1]='-' Then Zahl[0]:=1 Else Zahl[0]:=0;
 StrToGRZ:=Zahl
End;

Function GRZToStr(z:BigInt):String;
Var n,Laenge:Integer;
    s,t     :String;
    Null    :Boolean;
Begin
 If z[0]>1 Then Begin GRZToStr:=Fehlermeldung[z[0]];Exit End;
 Null:=True;Laenge:=Length(z)-1;
 If z[0]=1 Then s:='-' Else s:=' ';
 For n:=Laenge DownTo 1 Do
  Begin
   t:=IntToStr(z[n]);
   If n<Laenge Then t:=StringOfChar('0',LaengeInt-Length(t))+t;
   s:=s+t
  End;
 If (s=' ') Or (s='-') Or (s='-0') Then s:=' 0';
 GRZToStr:=s
End;

Function GleichGRZ(z1,z2:BigInt):Boolean;
Var i,Laenge1,Laenge2:Integer;
Begin
 Laenge1:=Length(z1)-1;Laenge2:=Length(z2)-1;
 If Laenge1<>Laenge2 Then Begin GleichGRZ:=False;Exit End;
 For i:=0 To Laenge1 Do
  If z1[i]<>z2[i] Then Begin GleichGRZ:=False;Break End
                  Else GleichGRZ:=True
End;

Function GroesserGRZ(z1,z2:BigInt):Boolean;
Var i,Laenge1,Laenge2:Integer;
Begin
 If GleichGRZ(z1,z2) Then Begin GroesserGRZ:=False;Exit End;
 Laenge1:=Length(z1)-1;Laenge2:=Length(z2)-1;
 If (z1[0]=0) And (z2[0]=1) Then Begin GroesserGRZ:=True;Exit End;
 If (z1[0]=1) And (z2[0]=0) Then Begin GroesserGRZ:=False;Exit End;
 If (z1[0]=0) And (z2[0]=0) Then
  Begin
   If Laenge1>Laenge2 Then Begin GroesserGRZ:=True;Exit End;
   If Laenge1<Laenge2 Then Begin GroesserGRZ:=False;Exit End;
   For i:=Laenge1 DownTo 1 Do
    Begin
     If z1[i]>z2[i] Then Begin GroesserGRZ:=True;Exit End;
     If z1[i]<z2[i] Then Begin GroesserGRZ:=False;Exit End
    End;
   GroesserGRZ:=False;Exit
  End;
 If (z1[0]=1) And (z2[0]=1) Then
  Begin
   If Laenge1>Laenge2 Then Begin GroesserGRZ:=False;Exit End;
   If Laenge1<Laenge2 Then Begin GroesserGRZ:=True;Exit End;
   For i:=Laenge1 DownTo 1 Do
    Begin
     If z1[i]>z2[i] Then Begin GroesserGRZ:=False;Exit End;
     If z1[i]<z2[i] Then Begin GroesserGRZ:=True;Exit End
    End;
   GroesserGRZ:=False
  End;
 GroesserGRZ:=False
End;

Function GroesserGleichGRZ(z1,z2:BigInt):Boolean;
Begin
 If GleichGRZ(z1,z2) Then GroesserGleichGRZ:=True
                     Else GroesserGleichGRZ:=GroesserGRZ(z1,z2)
End;

Function ExtendedToGRZ(z:Extended;Differenz:Integer):BigInt;
Var e,i,Laenge:Integer;
    s         :String;
    h         :BigInt;
Begin
 z:=Int(z);Str(z,s);Laenge:=Length(s);e:=0;SetLength(h,2);h[0]:=0;h[1]:=0;
 For i:=Laenge DownTo 1 Do
  If (s[i]='E') Or (s[i]='e') Then
   Begin e:=Trunc(Value(Copy(s,i+1,Laenge)));s:=Copy(s,1,i-1);Break End;
 s:=Copy(s,1,2)+Copy(s,4,Length(s));Laenge:=Length(s);
 If Laenge>e Then Begin ExtendedToGRZ:=StrToGRZ(Copy(s,1,e+2));Exit End;
 If Differenz<0 Then h[0]:=1;
 h[1]:=Abs(Differenz);s:=GRZToStr(AddGRZ(StrToGRZ(s),h));
 s:=s+StringOfChar('0',e+2-Laenge);ExtendedToGRZ:=StrToGRZ(s)
End;

Function KopiereGRZ(x:BigInt):BigInt;
Var i,Laenge:Integer;
    xx      :BigInt;
Begin
 Laenge:=Length(x);SetLength(xx,Laenge);Dec(Laenge);
 For i:=0 To Laenge Do xx[i]:=x[i];
 KopiereGRZ:=xx
End;

Function AddGRZ(Zahl1,Zahl2:BigInt):BigInt;
Var i,Laenge1,Laenge2:Integer;
    CF               :Byte;
    e                :Int64;
    Ergebnis         :BigInt;
    Vz,Vz1,Vz2       :Boolean;
Begin
 If Zahl1[0]>1 Then Begin AddGRZ:=Zahl1;Exit End;
 If Zahl2[0]>1 Then Begin AddGRZ:=Zahl2;Exit End;
 If Zahl1[0]=1 Then Vz1:=True Else Vz1:=False;
 If Zahl2[0]=1 Then Vz2:=True Else Vz2:=False;
 Zahl1[0]:=0;Zahl2[0]:=0;Vz:=False;
 If (Vz1 And Not(Vz2)) Or (Vz2 And Not(Vz1)) Then
  Begin
   Ergebnis:=SubGRZ(Zahl1,Zahl2);
   If Ergebnis[0]=1 Then If Vz2 Then Vz:=True Else
                    Else If Vz1 Then Vz:=True
  End
                                             Else
  Begin
   If Length(Zahl2)>Length(Zahl1) Then
    Begin Ergebnis:=Zahl2;Zahl2:=Zahl1;Zahl1:=Ergebnis End;
   Laenge1:=Length(Zahl1);Laenge2:=Length(Zahl2);
   CF:=0;SetLength(Ergebnis,Laenge1);Dec(Laenge1);
   If Vz1 And Vz2 Then Vz:=True;
   For i:=1 To Laenge1 Do
    Begin
     If i<Laenge2 Then e:=Zahl1[i]+Zahl2[i]+CF Else e:=Zahl1[i]+CF;
     If e>=MaxInt Then Begin Dec(e,MaxInt);CF:=1 End Else CF:=0;
     Ergebnis[i]:=e
    End;
   If CF<>0 Then Begin SetLength(Ergebnis,Laenge1+2);Ergebnis[Laenge1+1]:=CF End
  End;
 If Vz Then Ergebnis[0]:=1 Else Ergebnis[0]:=0;
 AddGRZ:=Ergebnis
End;

Function SubGRZ(Zahl1,Zahl2:BigInt):BigInt;
Var i,Laenge1,Laenge2:Integer;
    e                :Int64;
    BF               :Byte;
    Ergebnis         :BigInt;
    Vz,Vz1,Vz2       :Boolean;
Begin
 If Zahl1[0]>1 Then Begin SubGRZ:=Zahl1;Exit End;
 If Zahl2[0]>1 Then Begin SubGRZ:=Zahl2;Exit End;
 SetLength(Ergebnis,2);Ergebnis[0]:=0;
 If GleichGRZ(Zahl1,Zahl2) Then Begin Ergebnis[1]:=0;SubGRZ:=Ergebnis;Exit End;
 If Zahl1[0]=1 Then Vz1:=True Else Vz1:=False;
 If Zahl2[0]=1 Then Vz2:=True Else Vz2:=False;
 Zahl1[0]:=0;Zahl2[0]:=0;Vz:=False;
 If (Vz1 And Not(Vz2)) Or (Vz2 And Not(Vz1)) Then
  Begin
   Ergebnis:=AddGRZ(Zahl1,Zahl2);
   If Vz1 Then Vz:=True
  End
                                             Else
  Begin
   If GroesserGRZ(Zahl2,Zahl1) Then
    Begin
     Ergebnis:=Zahl2;Zahl2:=Zahl1;Zahl1:=Ergebnis;
     If Not(Vz1) And Not(Vz2) Then Vz:=True
    End
                                         Else If Vz1 And Vz2 Then Vz:=True;
   Laenge1:=Length(Zahl1);Laenge2:=Length(Zahl2);
   BF:=0;SetLength(Ergebnis,Laenge1);Dec(Laenge1);
   For i:=1 To Laenge1 Do
    Begin
     If i<Laenge2 Then e:=Zahl1[i]-Zahl2[i]-BF Else e:=Zahl1[i]-BF;
     If e<0 Then Begin Inc(e,MaxInt);BF:=1 End Else BF:=0;
     Ergebnis[i]:=e
    End;
   i:=Length(Ergebnis)-1;i:=Laenge1;
   While (i>0) And (Ergebnis[i]=0) Do Dec(i);
   If i<Laenge1 Then SetLength(Ergebnis,i+1)
  End;
 If Vz Then Ergebnis[0]:=1 Else Ergebnis[0]:=0;
 SubGRZ:=Ergebnis
End;

Function MulGRZ(Zahl1,Zahl2:BigInt):BigInt;
Var i,j,Laenge1,Laenge2:Integer;
    e,CF               :Int64;
    Ergebnis,t         :BigInt;
    Vz1,Vz2            :Boolean;
Begin
 If Zahl1[0]>1 Then Begin MulGRZ:=Zahl1;Exit End;
 If Zahl2[0]>1 Then Begin MulGRZ:=Zahl2;Exit End;
 If Zahl1[0]=1 Then Vz1:=True Else Vz1:=False;
 If Zahl2[0]=1 Then Vz2:=True Else Vz2:=False;
 Laenge1:=Length(Zahl1)-1;Laenge2:=Length(Zahl2)-1;CF:=0;
 SetLength(Ergebnis,Laenge1+Laenge2+1);SetLength(t,Laenge1+Laenge2+1);
 Zahl1[0]:=0;Zahl2[0]:=0;Ergebnis[0]:=0;t[0]:=0;
 If ((Laenge1=1) And (Zahl1[1]=0)) Or ((Laenge2=1) And (Zahl2[1]=0)) Then
  Begin SetLength(Ergebnis,2);Ergebnis[1]:=0;MulGRZ:=Ergebnis;Exit End;
  For i:=1 To Laenge2 Do
   Begin
    For j:=1 To Laenge1+Laenge2 Do t[j]:=0;
    For j:=1 To Laenge1 Do
     Begin
      e:=Zahl1[j]*Zahl2[i]+CF;
      If e>=MaxInt Then Begin CF:=e Div MaxInt;e:=e Mod MaxInt End Else CF:=0;
      t[i+j-1]:=e
     End;
    t[i+Laenge1]:=CF;CF:=0;Ergebnis:=AddGRZ(Ergebnis,t)
   End;
 If (Vz1 And Not(Vz2)) Or (Not(Vz1) And Vz2) Then Ergebnis[0]:=1;
 If Ergebnis[Laenge1+Laenge2]=0 Then SetLength(Ergebnis,Laenge1+Laenge2);
 MulGRZ:=Ergebnis
End;

Function DivGRZ(Zahl1,Zahl2:BigInt):BigInt;
Var Zahl,Ergebnis,Quotient:BigInt;
    Vz1,Vz2               :Boolean;
    i                     :Integer;
    z,z2                  :Extended;
Begin
 If Zahl1[0]>1 Then Begin DivGRZ:=Zahl1;Exit End;
 If Zahl2[0]>1 Then Begin DivGRZ:=Zahl2;Exit End;
 SetLength(Ergebnis,2);
 If Zahl2[1]=0 Then Begin Ergebnis[0]:=10;DivGRZ:=Ergebnis;Exit End;
 If Zahl1[0]=1 Then Vz1:=True Else Vz1:=False;
 If Zahl2[0]=1 Then Vz2:=True Else Vz2:=False;
 Zahl1[0]:=0;Zahl2[0]:=0;Ergebnis[0]:=0;
 z2:=Value(GRZToStr(Zahl2));z:=Value(GRZToStr(Zahl1))/z2;
 While z>=1 Do
  Begin
   Quotient:=ExtendedToGRZ(z,-1);Ergebnis:=AddGRZ(Ergebnis,Quotient);
   Quotient:=MulGRZ(Zahl2,Quotient);Zahl1:=SubGRZ(Zahl1,Quotient);
   z:=Value(GRZToStr(Zahl1))/z2
  End;
 If (Vz1 And Not(Vz2)) Or (Not(Vz1) And Vz2) Then Ergebnis[0]:=1;
 DivGRZ:=Ergebnis
End;

Function ModGRZ(Zahl1,Zahl2:BigInt):BigInt;
Var Zahl,Ergebnis:BigInt;
    z,z2         :Extended;
    i            :Integer;
    Vz1,Vz2      :Boolean;
Begin
 If Zahl1[0]>1 Then Begin ModGRZ:=Zahl1;Exit End;
 If Zahl2[0]>1 Then Begin ModGRZ:=Zahl2;Exit End;
 SetLength(Ergebnis,2);
 If Zahl2[1]=0 Then Begin Ergebnis[0]:=11;ModGRZ:=Ergebnis;Exit End;
 If Zahl1[0]=1 Then Vz1:=True Else Vz1:=False;
 If Zahl2[0]=1 Then Vz2:=True Else Vz2:=False;
 Zahl1[0]:=0;Zahl2[0]:=0;Ergebnis[0]:=0;
 z2:=Value(GRZToStr(Zahl2));z:=Value(GRZToStr(Zahl1))/z2;
 While z>=1 Do
  Begin
   Ergebnis:=ExtendedToGRZ(z,-1);Ergebnis:=MulGRZ(Zahl2,Ergebnis);
   Zahl1:=SubGRZ(Zahl1,Ergebnis);z:=Value(GRZToStr(Zahl1))/z2
  End;
 If Vz1 Then Zahl1[0]:=1;
 ModGRZ:=Zahl1
End;

Function ggTGRZ(x,y:BigInt):BigInt;
Var x1,y1,Null,h:BigInt;
Begin
 If x[0]>1 Then Begin ggTGRZ:=x;Exit End;
 If y[0]>1 Then Begin ggTGRZ:=y;Exit End;
 SetLength(Null,2);x[0]:=0;y[0]:=0;
 x1:=KopiereGRZ(x);y1:=KopiereGRZ(y);h:=x1;Null[0]:=0;Null[1]:=0;
 While GroesserGRZ(h,Null) Do Begin x1:=y1;y1:=h;h:=ModGRZ(x1,y1) End;
 ggTGRZ:=y1
End;

Function kgVGRZ(x,y:BigInt):BigInt;
Var h:BigInt;
Begin
 If x[0]>1 Then Begin kgVGRZ:=x;Exit End;
 If y[0]>1 Then Begin kgVGRZ:=y;Exit End;
 SetLength(h,2);x[0]:=0;y[0]:=0;
 If (x[1]=0) And (y[1]=0) Then Begin h[0]:=12;kgVGRZ:=h;Exit End;
 kgVGRZ:=DivGRZ(MulGRZ(x,y),ggTGRZ(x,y))
End;

Initialization

LaengeInt:=Trunc(Ln(MaxLongInt)/Ln(10));MaxInt:=Trunc(Exp(LaengeInt*Ln(10)))

End.
