unit Main; //12.09.2013

{$mode objfpc}{$H+}

interface

uses Classes,SysUtils,FileUtil,Forms,Controls,Dialogs,StdCtrls,ExtCtrls,GNURZ,GRZ;

type

{ TFormGRZ }

 TFormGRZ=class(TForm)
  ButtonBerechnen      :TButton;
  ButtonEnde           :TButton;
  LabeledEditErsteZahl :TLabeledEdit;
  LabeledEditErgebnis  :TLabeledEdit;
  LabeledEditZweiteZahl:TLabeledEdit;
  RadioGroup           :TRadioGroup;
  procedure ButtonBerechnenClick(Sender:TObject);
  procedure ButtonEndeClick(Sender:TObject);
  procedure FormCreate(Sender:TObject);
  procedure LabeledEditErsteZahlKeyPress(Sender:TObject;var Key:char);
  procedure RadioGroupClick(Sender:TObject);
end;

var FormGRZ:TFormGRZ;

implementation

{$R *.lfm}

{ TFormGRZ }

Var GnurzObjekt:TGnurz;

procedure TFormGRZ.ButtonBerechnenClick(Sender:TObject);
Const Meldung='GNURZ rechnet nur mit positiven Ganzzahlen!';
Var   ErgebnisGNZ,ErgebnisGRZ:String;
      Zahl1GNZ,Zahl2GNZ      :GNZTyp;
      Zahl1GRZ,Zahl2GRZ      :BigInt;
      Negativ                :Boolean;
Begin
 With GnurzObjekt Do
  Begin
   ResetErrormodus;
   If (LabeledEditErsteZahl.Text[1]='-') Or
      (LabeledEditZweiteZahl.Text[1]='-') Then Negativ:=True Else Negativ:=False;
   Zahl1GRZ:=StrToGRZ(LabeledEditErsteZahl.Text);
   Zahl2GRZ:=StrToGRZ(LabeledEditZweiteZahl.Text);
   Zahl1GNZ:=StrToGNZTyp(LabeledEditErsteZahl.Text);
   Zahl2GNZ:=StrToGNZTyp(LabeledEditZweiteZahl.Text);
   Case RadioGroup.ItemIndex Of
    0:Begin
       ErgebnisGRZ:=GRZToStr(AddGRZ(Zahl1GRZ,Zahl2GRZ));
       If Negativ Then ErgebnisGNZ:=Meldung
                  Else ErgebnisGNZ:=' '+GNZTypToStr(GNZAdd(Zahl1GNZ,Zahl2GNZ));
       If ErgebnisGRZ<>ErgebnisGNZ Then ErgebnisGRZ:=ErgebnisGRZ+' Fehler Addition! '+ErgebnisGNZ
      End;
    1:Begin
       ErgebnisGRZ:=GRZToStr(SubGRZ(Zahl1GRZ,Zahl2GRZ));
       If Negativ Then ErgebnisGNZ:=Meldung
                  Else ErgebnisGNZ:=' '+GNZTypToStr(GNZSub(Zahl1GNZ,Zahl2GNZ));
       If ErgebnisGRZ<>ErgebnisGNZ Then ErgebnisGRZ:=ErgebnisGRZ+' Fehler Subtraktion! '+ErgebnisGNZ
      End;
    2:Begin
       ErgebnisGRZ:=GRZToStr(MulGRZ(Zahl1GRZ,Zahl2GRZ));
       If Negativ Then ErgebnisGNZ:=Meldung
                  Else ErgebnisGNZ:=' '+GNZTypToStr(GNZMul(Zahl1GNZ,Zahl2GNZ));
       If ErgebnisGRZ<>ErgebnisGNZ Then ErgebnisGRZ:=ErgebnisGRZ+' Fehler Multiplikation! '+ErgebnisGNZ
      End;
    3:Begin
       ErgebnisGRZ:=GRZToStr(DivGRZ(Zahl1GRZ,Zahl2GRZ));
       If Negativ Then ErgebnisGNZ:=Meldung
                  Else ErgebnisGNZ:=' '+GNZTypToStr(GNZDiv(Zahl1GNZ,Zahl2GNZ));
       If ErgebnisGRZ<>ErgebnisGNZ Then ErgebnisGRZ:=ErgebnisGRZ+' Fehler Division! '+ErgebnisGNZ
      End;
    4:Begin
       ErgebnisGRZ:=GRZToStr(ModGRZ(Zahl1GRZ,Zahl2GRZ));
       If Negativ Then ErgebnisGNZ:=Meldung
                  Else ErgebnisGNZ:=' '+GNZTypToStr(GNZMod(Zahl1GNZ,Zahl2GNZ));
       If ErgebnisGRZ<>ErgebnisGNZ Then ErgebnisGRZ:=ErgebnisGRZ+' Fehler Rest-Division! '+ErgebnisGNZ
      End;
    5:Begin
       ErgebnisGRZ:=GRZToStr(ggTGRZ(Zahl1GRZ,Zahl2GRZ));
       If Negativ Then ErgebnisGNZ:=Meldung
                  Else ErgebnisGNZ:=' '+GNZTypToStr(GNZggT(Zahl1GNZ,Zahl2GNZ));
       If ErgebnisGRZ<>ErgebnisGNZ Then ErgebnisGRZ:=ErgebnisGRZ+' Fehler ggT! '+ErgebnisGNZ
      End;
    6:Begin
       ErgebnisGRZ:=GRZToStr(kgVGRZ(Zahl1GRZ,Zahl2GRZ));
       If Negativ Then ErgebnisGNZ:=Meldung
                  Else ErgebnisGNZ:=' '+GNZTypToStr(GNZkgV(Zahl1GNZ,Zahl2GNZ));
       If ErgebnisGRZ<>ErgebnisGNZ Then ErgebnisGRZ:=ErgebnisGRZ+' Fehler kgV! '+ErgebnisGNZ
      End
   End;
   LabeledEditErgebnis.Text:=ErgebnisGRZ
  End
end;

procedure TFormGRZ.ButtonEndeClick(Sender:TObject);
begin GnurzObjekt.Free;Close end;

procedure TFormGRZ.FormCreate(Sender:TObject);
begin GnurzObjekt:=TGnurz.Create;ButtonBerechnenClick(Sender) end;

procedure TFormGRZ.LabeledEditErsteZahlKeyPress(Sender:TObject;var Key:char);
Var s:String;
begin
 If Sender=LabeledEditErsteZahl Then s:=LabeledEditErsteZahl.Text;
 If Sender=LabeledEditZweiteZahl Then s:=LabeledEditZweiteZahl.Text;
 If (Key=#13) Or (Length(s)>150) Then Key:=#0
                                 Else
  If Not(Key in [#8,#48..#57,'-']) Then Key:=#0;
 If Key='-' Then If Length(s)<>0 Then Key:=#0
end;

procedure TFormGRZ.RadioGroupClick(Sender: TObject);
begin ButtonBerechnenClick(Sender) end;

end.
